import { ICoordinates } from "../../../../Core/Interfaces";
import { MoveDirection, MoveDirectionAlt } from "../../../../Enums";
import { IParticles } from "../../../../Options/Interfaces/Particles/IParticles";
import { IEmitterRate } from "./IEmitterRate";
import { IEmitterLife } from "./IEmitterLife";
import { RecursivePartial } from "../../../../Types";
import { IEmitterSize } from "./IEmitterSize";
import { IAnimatableColor } from "../../../../Options/Interfaces/IAnimatableColor";
import { EmitterShapeType } from "../../Enums/EmitterShapeType";
export interface IEmitter {
    autoPlay: boolean;
    size?: IEmitterSize;
    direction?: MoveDirection | keyof typeof MoveDirection | MoveDirectionAlt | number;
    fill: boolean;
    life: IEmitterLife;
    name?: string;
    particles?: RecursivePartial<IParticles>;
    position?: RecursivePartial<ICoordinates>;
    rate: IEmitterRate;
    shape: EmitterShapeType | keyof typeof EmitterShapeType;
    spawnColor?: IAnimatableColor;
    startCount: number;
}
